summaryrefslogtreecommitdiff
path: root/net-firewall/fwknop
diff options
context:
space:
mode:
authorPalica <palica+gitlab@liguros.net>2020-06-23 22:35:08 +0200
committerPalica <palica+gitlab@liguros.net>2020-06-23 22:35:08 +0200
commitecdac123787b96ce6649f0f91da12ea6458cc2b1 (patch)
treeb89c74d9e6fe6e8aebc4c77bcbeb4ab73214127d /net-firewall/fwknop
parent1be72aa41cf41dedadeecf59dca9f01de6381f5e (diff)
downloadbaldeagleos-repo-ecdac123787b96ce6649f0f91da12ea6458cc2b1.tar.gz
baldeagleos-repo-ecdac123787b96ce6649f0f91da12ea6458cc2b1.tar.xz
baldeagleos-repo-ecdac123787b96ce6649f0f91da12ea6458cc2b1.zip
Updating liguros repo
Diffstat (limited to 'net-firewall/fwknop')
-rw-r--r--net-firewall/fwknop/Manifest2
-rw-r--r--net-firewall/fwknop/files/fwknop-2.6.10_fno-common_fix.patch23
-rw-r--r--net-firewall/fwknop/files/fwknopd.confd21
-rw-r--r--net-firewall/fwknop/files/fwknopd.init91
-rw-r--r--net-firewall/fwknop/files/fwknopd.service12
-rw-r--r--net-firewall/fwknop/files/fwknopd.tmpfiles.conf1
-rw-r--r--net-firewall/fwknop/fwknop-2.6.10-r1.ebuild138
-rw-r--r--net-firewall/fwknop/fwknop-2.6.9-r1.ebuild144
-rw-r--r--net-firewall/fwknop/metadata.xml27
9 files changed, 459 insertions, 0 deletions
diff --git a/net-firewall/fwknop/Manifest b/net-firewall/fwknop/Manifest
new file mode 100644
index 000000000000..d49b6b5fc1a3
--- /dev/null
+++ b/net-firewall/fwknop/Manifest
@@ -0,0 +1,2 @@
+DIST fwknop-2.6.10.tar.gz 1988197 BLAKE2B d4c2010c64ab160f0edc02e2b1530749ee47ff6ed16d6b556d366daef7ce5e22ef38fbbbf6e8cfaa14e0d9706ba2b65937b03c70b54b3429ff1732ae33c1852c SHA512 3b3e35eda574abd1759431c88677eea7078c54cb3252c0ee0e1019b5b8224ed8844d30760da70a952e1cd92b04715a547f6effabda54678f791fff9afa32cd80
+DIST fwknop-2.6.9.tar.gz 3043542 BLAKE2B 11440fa0fe5e990a269587fa9ee1da0242f3dc939d6dc185d6adff9e9c995a8ffe902a6351a057c619cb6ff056519caea38f7b865978fe5ac810a39281bb3fc3 SHA512 4706560d44c911c8604059d88dded9c1b8c333399d90ec7dc366c0fba96c79680bdbf1b8b5e76cc34aaf3a1e58fff80db8f5f20c96d57481bdb476a9b99f4d1b
diff --git a/net-firewall/fwknop/files/fwknop-2.6.10_fno-common_fix.patch b/net-firewall/fwknop/files/fwknop-2.6.10_fno-common_fix.patch
new file mode 100644
index 000000000000..9c144cc1eddd
--- /dev/null
+++ b/net-firewall/fwknop/files/fwknop-2.6.10_fno-common_fix.patch
@@ -0,0 +1,23 @@
+From a87325b0816a79329cf0b4d4f9ebf247ead117db Mon Sep 17 00:00:00 2001
+From: Jakub Jelen <jjelen@redhat.com>
+Date: Mon, 10 Feb 2020 15:21:56 +0100
+Subject: [PATCH] Unbreak build with gcc10 (-fno-common)
+
+Signed-off-by: Jakub Jelen <jjelen@redhat.com>
+---
+ client/log_msg.h | 2 +-
+ 1 file changed, 1 insertion(+), 1 deletion(-)
+
+diff --git a/client/log_msg.h b/client/log_msg.h
+index cc17716b..3dda1614 100644
+--- a/client/log_msg.h
++++ b/client/log_msg.h
+@@ -38,7 +38,7 @@ enum
+ LOG_VERBOSITY_INFO, /*!< Constant to define a INFO message */
+ LOG_VERBOSITY_DEBUG, /*!< Constant to define a DEBUG message */
+ LOG_LAST_VERBOSITY
+-} log_level_t;
++};
+
+ #define LOG_DEFAULT_VERBOSITY LOG_VERBOSITY_NORMAL /*!< Default verbosity to use */
+
diff --git a/net-firewall/fwknop/files/fwknopd.confd b/net-firewall/fwknop/files/fwknopd.confd
new file mode 100644
index 000000000000..63bcd01dd82f
--- /dev/null
+++ b/net-firewall/fwknop/files/fwknopd.confd
@@ -0,0 +1,21 @@
+# /etc/conf.d/fwknopd: config file for /etc/init.d/fwknopd
+
+# Path to the fwknopd config directory (needs to be an absolute path).
+
+FWKNOPD_CONFDIR="/etc/fwknop"
+
+
+# Additional options to pass to fwknopd.
+# Refer to the fwknopd(8) manpage for more information.
+
+#FWKNOPD_OPTS=""
+
+
+# Pid file to use (needs to be an absolute path).
+
+#FWKNOPD_PIDFILE="/run/fwknop/fwknopd.pid"
+
+
+# Path to the fwknopd binary (needs to be an absolute path).
+
+#FWKNOPD_BINARY="/usr/sbin/fwknopd"
diff --git a/net-firewall/fwknop/files/fwknopd.init b/net-firewall/fwknop/files/fwknopd.init
new file mode 100644
index 000000000000..dda1bf03156e
--- /dev/null
+++ b/net-firewall/fwknop/files/fwknopd.init
@@ -0,0 +1,91 @@
+#!/sbin/openrc-run
+# Copyright 1999-2016 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+extra_commands="checkconfig"
+extra_started_commands="reload"
+
+: ${FWKNOPD_BINARY:=/usr/sbin/fwknopd}
+: ${FWKNOPD_CONFDIR:=/etc/fwknop}
+: ${FWKNOPD_CONFIG:=${FWKNOPD_CONFDIR}/fwknopd.conf}
+: ${FWKNOPD_PIDFILE:=/run/fwknop/${SVCNAME}.pid}
+
+depend() {
+ after iptables ip6tables ebtables firewall
+ use logger
+ if [ "${rc_need+set}" = "set" ]; then
+ : # Do nothing, the user has explicitly set rc_need
+ elif [ -f "${FWKNOPD_CONFIG}" ]; then
+ local x warn_intf
+ for x in $(awk '/^[[:blank:]]*PCAP_INTF/{ sub(";$", ""); print $2 }' "${FWKNOPD_CONFIG}" 2>/dev/null); do
+ warn_intf="${warn_intf} ${x}"
+ done
+ if [ -n "${warn_intf}" ]; then
+ need net
+ ewarn "You are binding an interface in PCAP_INTF statement in your fwknopd.conf!"
+ ewarn "You must add rc_need=\"net.FOO\" to your /etc/conf.d/${SVCNAME},"
+ ewarn "where FOO is the following interface(s):"
+ ewarn "${warn_intf}"
+ else
+ # If PCAP_INTF and PCAP_FILE are not set, then fwknopd uses eth0
+ if ! grep -q '^[[:blank:]]*PCAP_FILE' "${FWKNOPD_CONFIG}"; then
+ need net
+ ewarn "You are not binding any interface in PCAP_INTF statement in your fwknopd.conf,"
+ ewarn "neither you are providing PCAP_FILE option. Thus fwknopd will listen on eth0."
+ ewarn "You must add rc_need=\"net.eth0\" to your /etc/conf.d/${SVCNAME}."
+ fi
+ fi
+ fi
+}
+
+checkconfig() {
+ if [ ! -e "${FWKNOPD_CONFDIR}"/fwknopd.conf ]; then
+ eerror "You need ${FWKNOPD_CONFDIR}/fwknopd.conf file to run fwknopd"
+ eerror "Example is located at /etc/fwknop/fwknopd.conf.example"
+ return 1
+ fi
+
+ if [ ! -e "${FWKNOPD_CONFDIR}"/access.conf ]; then
+ eerror "You need ${FWKNOPD_CONFDIR}/access.conf file to run fwknopd"
+ eerror "Example is located at /etc/fwknop/access.conf.example"
+ return 1
+ fi
+
+ [ "${FWKNOPD_PIDFILE}" != "/run/fwknop/${SVCNAME}.pid" ] \
+ && FWKNOPD_OPTS="${FWKNOPD_OPTS} --pid-file=${FWKNOPD_PIDFILE}"
+
+ [ "${FWKNOPD_CONFDIR}" != "/etc/fwknop" ] \
+ && FWKNOPD_OPTS="${FWKNOPD_OPTS} \
+ --config=${FWKNOPD_CONFDIR}/fwknopd.conf \
+ --access-file=${FWKNOPD_CONFDIR}/access.conf"
+
+ return 0
+}
+
+start() {
+ checkconfig || return 1
+
+ ebegin "Starting ${SVCNAME}"
+ start-stop-daemon --start \
+ --exec ${FWKNOPD_BINARY} --pidfile ${FWKNOPD_PIDFILE} \
+ -- ${FWKNOPD_OPTS}
+ eend $?
+}
+
+stop() {
+ if [ "${RC_CMD}" = "restart" ]; then
+ checkconfig || return 1
+ fi
+
+ ebegin "Stopping ${SVCNAME}"
+ start-stop-daemon --stop --pidfile ${FWKNOPD_PIDFILE}
+ eend $?
+}
+
+reload() {
+ checkconfig || return 1
+
+ ebegin "Reloading ${SVCNAME} configuration"
+ start-stop-daemon --signal HUP --pidfile ${FWKNOPD_PIDFILE}
+ eend $?
+}
diff --git a/net-firewall/fwknop/files/fwknopd.service b/net-firewall/fwknop/files/fwknopd.service
new file mode 100644
index 000000000000..d2e8c3125200
--- /dev/null
+++ b/net-firewall/fwknop/files/fwknopd.service
@@ -0,0 +1,12 @@
+[Unit]
+Description=Firewall Knock Operator Daemon
+After=network-online.target
+
+[Service]
+Type=forking
+PIDFile=/run/fwknop/fwknopd.pid
+ExecStart=/usr/sbin/fwknopd
+ExecReload=/bin/kill -HUP $MAINPID
+
+[Install]
+WantedBy=multi-user.target
diff --git a/net-firewall/fwknop/files/fwknopd.tmpfiles.conf b/net-firewall/fwknop/files/fwknopd.tmpfiles.conf
new file mode 100644
index 000000000000..b7cb3856b056
--- /dev/null
+++ b/net-firewall/fwknop/files/fwknopd.tmpfiles.conf
@@ -0,0 +1 @@
+d /run/fwknop 0700 root root -
diff --git a/net-firewall/fwknop/fwknop-2.6.10-r1.ebuild b/net-firewall/fwknop/fwknop-2.6.10-r1.ebuild
new file mode 100644
index 000000000000..786366d6895e
--- /dev/null
+++ b/net-firewall/fwknop/fwknop-2.6.10-r1.ebuild
@@ -0,0 +1,138 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+# Python extension supports only Python 2.
+# See https://github.com/mrash/fwknop/issues/167
+PYTHON_COMPAT=( python2_7 )
+DISTUTILS_SINGLE_IMPL=1
+DISTUTILS_OPTIONAL=1
+
+inherit autotools distutils-r1 eutils linux-info readme.gentoo-r1 systemd
+
+DESCRIPTION="Single Packet Authorization and Port Knocking application"
+HOMEPAGE="https://www.cipherdyne.org/fwknop/"
+SRC_URI="https://www.cipherdyne.org/fwknop/download/${P}.tar.gz"
+
+LICENSE="GPL-2+"
+SLOT="0"
+KEYWORDS="~amd64 ~x86"
+IUSE="+client extras firewalld gdbm gpg +iptables nfqueue python +server udp-server"
+
+DEPEND="
+ client? ( net-misc/wget[ssl] )
+ firewalld? ( net-firewall/firewalld[${PYTHON_SINGLE_USEDEP}] )
+ gdbm? ( sys-libs/gdbm )
+ gpg? (
+ app-crypt/gpgme
+ dev-libs/libassuan
+ dev-libs/libgpg-error
+ )
+ iptables? ( net-firewall/iptables )
+ nfqueue? ( net-libs/libnetfilter_queue )
+ python? ( ${PYTHON_DEPS} )
+ server? ( !nfqueue? ( !udp-server? ( net-libs/libpcap ) ) )
+"
+RDEPEND="${DEPEND}"
+
+REQUIRED_USE="
+ nfqueue? ( server )
+ python? ( ${PYTHON_REQUIRED_USE} )
+ server? ( ^^ ( firewalld iptables ) )
+ udp-server? ( server )
+"
+
+PATCHES=( "${FILESDIR}/${PN}-2.6.10_fno-common_fix.patch" )
+
+DOCS=( AUTHORS ChangeLog README )
+
+DISABLE_AUTOFORMATTING=1
+DOC_CONTENTS="
+Example configuration files were installed to '${EPREFIX}/etc/fwknopd/'.
+Please edit them to suit your needs and then remove the .example suffix.
+
+fwknopd supports several backends: firewalld, iptables, ipfw, pf, ipf.
+You can set the desired backend via FIREWALL_EXE option in fwknopd.conf
+instead of the default one chosen at compile time.
+"
+
+pkg_setup() {
+ linux-info_pkg_setup
+ python-single-r1_pkg_setup
+}
+
+src_prepare() {
+ default_src_prepare
+
+ # Install example configs with .example suffix.
+ if use server; then
+ sed -i -e 's|conf;|conf.example;|g' Makefile.am || die
+ fi
+
+ eautoreconf
+}
+
+src_configure() {
+ local myeconfargs=(
+ --localstatedir="${EPREFIX}/run"
+ $(use_enable client)
+ $(use_enable !gdbm file-cache)
+ $(use_enable nfqueue nfq-capture)
+ $(use_enable server)
+ $(use_enable udp-server)
+ $(use_with gpg gpgme)
+ )
+ use firewalld && myeconfargs+=(--with-firewalld="${EPREFIX}/usr/sbin/firewalld")
+ use iptables && myeconfargs+=(--with-iptables="${EPREFIX}/sbin/iptables")
+
+ econf "${myeconfargs[@]}"
+}
+
+src_install() {
+ default_src_install
+
+ if use extras; then
+ dodoc extras/apparmor/usr.sbin.fwknopd
+ dodoc extras/console-qr/console-qr.sh
+ dodoc extras/fwknop-launcher/*
+ fi
+
+ if use server; then
+ newinitd "${FILESDIR}/fwknopd.init" fwknopd
+ newconfd "${FILESDIR}/fwknopd.confd" fwknopd
+ systemd_dounit "${FILESDIR}/fwknopd.service"
+ systemd_newtmpfilesd "${FILESDIR}/fwknopd.tmpfiles.conf" fwknopd.conf
+ readme.gentoo_create_doc
+ fi
+
+ if use python; then
+ # Redefine DOCS, otherwise distutils-r1 eclass interferes.
+ local DOCS=()
+ cd python || die
+ distutils-r1_src_install
+ fi
+
+ find "${ED}" -type f -name "*.la" -delete || die
+}
+
+pkg_postinst() {
+ if use server; then
+ readme.gentoo_print_elog
+
+ if ! linux_config_exists || ! linux_chkconfig_present NETFILTER_XT_MATCH_COMMENT; then
+ echo
+ ewarn "fwknopd daemon relies on the 'comment' match in order to expire"
+ ewarn "created firewall rules, which is an important security feature."
+ ewarn "Please enable NETFILTER_XT_MATCH_COMMENT support in your kernel."
+ echo
+ fi
+ if use nfqueue && \
+ ! linux_config_exists || ! linux_chkconfig_present NETFILTER_XT_TARGET_NFQUEUE; then
+ echo
+ ewarn "fwknopd daemon relies on the 'NFQUEUE' target for NFQUEUE mode."
+ ewarn "Please enable NETFILTER_XT_TARGET_NFQUEUE support in your kernel."
+ echo
+ fi
+ fi
+}
diff --git a/net-firewall/fwknop/fwknop-2.6.9-r1.ebuild b/net-firewall/fwknop/fwknop-2.6.9-r1.ebuild
new file mode 100644
index 000000000000..ff9bea4cb409
--- /dev/null
+++ b/net-firewall/fwknop/fwknop-2.6.9-r1.ebuild
@@ -0,0 +1,144 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+# Python extension supports only Python 2.
+# See https://github.com/mrash/fwknop/issues/167
+PYTHON_COMPAT=( python2_7 )
+DISTUTILS_OPTIONAL=1
+DISTUTILS_SINGLE_IMPL=1
+
+inherit autotools distutils-r1 eutils linux-info ltprune readme.gentoo-r1 systemd
+
+DESCRIPTION="Single Packet Authorization and Port Knocking application"
+HOMEPAGE="https://www.cipherdyne.org/fwknop/ https://github.com/mrash/fwknop"
+SRC_URI="https://github.com/mrash/${PN}/archive/${PV}.tar.gz -> ${P}.tar.gz"
+
+LICENSE="GPL-2+"
+SLOT="0"
+KEYWORDS="~amd64 ~x86"
+IUSE="+client extras firewalld gdbm gpg +iptables nfqueue python +server udp-server"
+
+DEPEND="
+ client? ( net-misc/wget[ssl] )
+ firewalld? ( net-firewall/firewalld[${PYTHON_SINGLE_USEDEP}] )
+ gdbm? ( sys-libs/gdbm )
+ gpg? (
+ app-crypt/gpgme
+ dev-libs/libassuan
+ dev-libs/libgpg-error
+ )
+ iptables? ( net-firewall/iptables )
+ nfqueue? ( net-libs/libnetfilter_queue )
+ python? ( ${PYTHON_DEPS} )
+ server? ( !nfqueue? ( !udp-server? ( net-libs/libpcap ) ) )
+"
+RDEPEND="${DEPEND}"
+
+REQUIRED_USE="
+ nfqueue? ( server )
+ python? ( ${PYTHON_REQUIRED_USE} )
+ server? ( ^^ ( firewalld iptables ) )
+ udp-server? ( server )
+"
+
+DOCS=( AUTHORS ChangeLog README.md )
+
+DISABLE_AUTOFORMATTING=1
+DOC_CONTENTS="
+Example configuration files were installed to '${EPREFIX}/etc/fwknopd/'.
+Please edit them to suit your needs and then remove the .example suffix.
+
+fwknopd supports several backends: firewalld, iptables, ipfw, pf, ipf.
+You can set the desired backend via FIREWALL_EXE option in fwknopd.conf
+instead of the default one chosen at compile time.
+"
+
+pkg_setup() {
+ linux-info_pkg_setup
+ python-single-r1_pkg_setup
+}
+
+src_prepare() {
+ default_src_prepare
+
+ # Install example configs with .example suffix.
+ if use server; then
+ sed -i -e 's|conf;|conf.example;|g' Makefile.am || die
+ fi
+
+ eautoreconf
+}
+
+src_configure() {
+ local myeconfargs=(
+ --localstatedir="${EPREFIX}/run"
+ $(use_enable client)
+ $(use_enable !gdbm file-cache)
+ $(use_enable nfqueue nfq-capture)
+ $(use_enable server)
+ $(use_enable udp-server)
+ $(use_with gpg gpgme)
+ )
+ use firewalld && myeconfargs+=(--with-firewalld="${EPREFIX}/usr/sbin/firewalld")
+ use iptables && myeconfargs+=(--with-iptables="${EPREFIX}/sbin/iptables")
+
+ econf "${myeconfargs[@]}"
+}
+
+src_compile() {
+ default_src_compile
+
+ if use python; then
+ cd python || die
+ distutils-r1_src_compile
+ fi
+}
+
+src_install() {
+ default_src_install
+ prune_libtool_files --modules
+
+ if use extras; then
+ dodoc extras/apparmor/usr.sbin.fwknopd
+ dodoc extras/console-qr/console-qr.sh
+ dodoc extras/fwknop-launcher/*
+ fi
+
+ if use server; then
+ newinitd "${FILESDIR}/fwknopd.init" fwknopd
+ newconfd "${FILESDIR}/fwknopd.confd" fwknopd
+ systemd_dounit extras/systemd/fwknopd.service
+ systemd_newtmpfilesd extras/systemd/fwknopd.tmpfiles.conf fwknopd.conf
+ readme.gentoo_create_doc
+ fi
+
+ if use python; then
+ # Redefine DOCS, otherwise distutils-r1 eclass interferes.
+ local DOCS=()
+ cd python || die
+ distutils-r1_src_install
+ fi
+}
+
+pkg_postinst() {
+ if use server; then
+ readme.gentoo_print_elog
+
+ if ! linux_config_exists || ! linux_chkconfig_present NETFILTER_XT_MATCH_COMMENT; then
+ echo
+ ewarn "fwknopd daemon relies on the 'comment' match in order to expire"
+ ewarn "created firewall rules, which is an important security feature."
+ ewarn "Please enable NETFILTER_XT_MATCH_COMMENT support in your kernel."
+ echo
+ fi
+ if use nfqueue && \
+ ! linux_config_exists || ! linux_chkconfig_present NETFILTER_XT_TARGET_NFQUEUE; then
+ echo
+ ewarn "fwknopd daemon relies on the 'NFQUEUE' target for NFQUEUE mode."
+ ewarn "Please enable NETFILTER_XT_TARGET_NFQUEUE support in your kernel."
+ echo
+ fi
+ fi
+}
diff --git a/net-firewall/fwknop/metadata.xml b/net-firewall/fwknop/metadata.xml
new file mode 100644
index 000000000000..44885c14e714
--- /dev/null
+++ b/net-firewall/fwknop/metadata.xml
@@ -0,0 +1,27 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd">
+<pkgmetadata>
+ <maintainer type="person">
+ <email>hlein@korelogic.com</email>
+ <name>Hank Leininger</name>
+ </maintainer>
+ <maintainer type="project">
+ <email>proxy-maint@gentoo.org</email>
+ <name>Proxy Maintainers</name>
+ </maintainer>
+ <use>
+ <flag name="client">Build fwknop client</flag>
+ <flag name="extras">Install utility scripts and AppArmor policy for fwknopd</flag>
+ <flag name="firewalld">Use <pkg>net-firewall/firewalld</pkg> as the default server backend</flag>
+ <flag name="gdbm">Use <pkg>sys-libs/gdbm</pkg> to store fwknopd digest cache</flag>
+ <flag name="gpg">Enable GPG support via <pkg>app-crypt/gpgme</pkg></flag>
+ <flag name="iptables">Use <pkg>net-firewall/iptables</pkg> as the default server backend</flag>
+ <flag name="nfqueue">Enable UDP-only NFQUEUE server mode (no <pkg>net-libs/libpcap</pkg> dependency)</flag>
+ <flag name="server">Build fwknopd server</flag>
+ <flag name="udp-server">Enable UDP-only server mode (no <pkg>net-libs/libpcap</pkg> dependency)</flag>
+ </use>
+ <upstream>
+ <remote-id type="github">mrash/fwknop</remote-id>
+ </upstream>
+ <origin>gentoo-staging</origin>
+</pkgmetadata>